import os

import pygame

from pygame.locals import *
from data import *

import random

from globalvars import *
from textrect import *
from pgu import engine
from pgu import timer
from game import Button



class DialogBox(object):
	def __init__(self, image, pos, size, text, boxNum):
		self.image = image
		self.pos = pos
		self.size = size
		self.text = text
		self.boxNum = boxNum
		if self.boxNum == 1:
			self.textRect = pygame.Rect((pos[0]+147, pos[1]), size)
		else:
			self.textRect = pygame.Rect(pos, size)
			
		self.font = pygame.font.Font(os.path.join("data","lcd-dot-matrix.ttf"),20)
		
		self.colour = 0,0,0
		
		self.robotImgFrame = loadImage("robot_img_frame.png")
		
	def update(self, screen):
		if self.boxNum == 1:
			renderedText = render_textrect(self.text, self.font, self.textRect, self.colour, 0)
		else:
			renderedText = render_textrect(self.text, self.font, self.textRect, self.colour, 0)
		
		screen.blit(renderedText, self.textRect.topleft)
		
		if self.image != "":
			if self.boxNum == 1:
				screen.blit(self.robotImgFrame,self.pos)
				screen.blit(self.image,(self.pos[0]+17, self.pos[1]+60))
			else:
				screen.blit(self.robotImgFrame,(self.pos[0]+580, self.pos[1]))
				screen.blit(self.image,(self.pos[0]+597, self.pos[1]+60))
		
	def changeText(self, image, newText, screen):
		self.text = newText
		self.image = image
		self.update(screen)		
		
class Scene1:
	
	dialog1 = ["Psychiatrist: Hello Roger. Let's see. It says here, you are a mining robot?",
	"I see. How can I help you today?", 
	"It's okay. Take your time.", 
	"...", 
	"...",
	"What are your dreams about?"]

	
	dialog2 = ["Roger: Yes, yes that's right. Ever since I was put into production.", 
	"Well, um, I've never really done this before. Wow, how to start. Hmm.",
	"You see, I've been having these dreams.", 
	"I've never really paid much attention to dreams before. But this dream has been the same dream each night for a month!", 
	"I think I'm going crazy!",
	"Every night it starts the same way: a bright light, a blue planet, and then a strange shadowy creature appears..."]
	
	pictures = [None, None, None, None, None]
	
			

class CutsceneUI(engine.State):	
	def __init__(self, game, scene, curPlanet, heavenlyBodies):
		self.game = game
		self.scene = scene
		self.cutScene = 0
		self.curPlanet = curPlanet
		self.heavenlyBodies = heavenlyBodies
		
	def init(self):
		self.playCredits = False
		if self.game.sound:
			self.clickSound = loadSound("button-click.ogg")
			if self.game.musicPlaying != "dialog":
				pygame.mixer.music.fadeout(500)
				
				loadMusic("song04.ogg")
				pygame.mixer.music.play(-1)
				
				self.game.musicPlaying = "dialog"
		else:
			self.clickSound = None
		
		#exec('self.dialog1 = DialogBox(loadImage("robot_red.png"), (75,10), (575,175), Scene%d().dialog1[0], 1)' % self.game.cutsceneNumber)
		#exec('self.dialog2 = DialogBox(loadImage("robot_green.png"), (10,200), (575,175), Scene%d().dialog2[0], 2)' % self.game.cutsceneNumber)
		self.dialogNum = 0
		self.dialog1 = DialogBox(loadImage(self.scene.topLines[self.dialogNum]['image']),(75,10), (575,175),self.scene.topLines[self.dialogNum]['text'],1)
		self.dialog2 = DialogBox(loadImage(self.scene.bottomLines[self.dialogNum]['image']),(10,200), (575,175),self.scene.bottomLines[self.dialogNum]['text'],2)
		
		
		self.done = False
		
		self.nextButton = Button(loadImage("next_button.png"), [690, 550], True)
		self.skipButton = Button(loadImage("skip_button.png"), [600, 550], True)
		self.background = loadImage("space_backdrop1.png")
	
	def loop(self):	
		if self.nextButton.release:
			if self.clickSound != None:
				self.clickSound.play(0)
				
		if self.skipButton.release:			
			if self.game.playIntro == True:
				self.game.playIntro = False
				
				import game
				return game.NavUI(self.game)
			else:	
				if self.game.skipTradingScreen == True:
					self.game.skipTradingScreen = False
					import game
					return game.NavUI(self.game)
					
				import trade
				return trade.TradeUI(self.game, self.heavenlyBodies, self.curPlanet)
				
		try:
			self.dialog1.changeText(loadImage(self.scene.topLines[self.dialogNum]['image']),self.scene.topLines[self.dialogNum]['text'],self.screen)
			self.dialog2.changeText(loadImage(self.scene.bottomLines[self.dialogNum]['image']),self.scene.bottomLines[self.dialogNum]['text'],self.screen)
			
		except IndexError:
			self.done = True
			self.dialogNum = 0
			
		if self.done == True:
			if self.game.skipTradingScreen == True:
				self.game.playIntro = False
				self.game.skipTradingScreen = False
				import game
				return game.NavUI(self.game)
			
			#import game
			#return game.NavUI(self.game)
			if self.game.playCredits != True:
				if self.game.playIntro == True:
					self.game.playIntro = False
					import game
					return game.NavUI(self.game)
					
				else:
					if(self.scene.skipTradingScreen):
						import game
						return game.NavUI(self.game)
					else:
						import trade
						return trade.TradeUI(self.game, self.heavenlyBodies, self.curPlanet)
					
				#else:	
					#import game
					#return game.NavUI(self.game)
			else:
				import menu
				return menu.Menu(self.game)
			
		if self.nextButton.release:
			self.dialogNum += 1
	
	def update(self,screen):
		return self.paint(screen)
	
	def paint(self,screen):
		self.screen = screen
		#screen.fill((0,0,0))
		screen.blit(self.background, (0,0))
		
		#for thing in self.Dialogs:
		#	thing.update(screen)
			
		self.dialog1.update(screen)
		self.dialog2.update(screen)
		
		self.nextButton.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
		#self.skipButton.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
		
		#font = pygame.font.Font(os.path.join("data","Wanta.ttf"),35)
		#instructions = font.render("Click to advance text.",1, (247,199,3))
		#screen.blit(instructions, (100,550))
		
		exec('pictures = Scene%d().pictures') % self.game.cutsceneNumber
		for picture in pictures:
			if picture != None:
				if pictures.index(picture) == self.dialogNum - 1: #The array index starts at 0 so subtract 1 from the dialog number
					screen.blit(picture, (0,400))
			
		pygame.display.update()
	
	def event(self,e):
		if e.type == KEYDOWN:
			if e.key == K_ESCAPE:
				import menu
				return menu.Menu(self.game)
		if e.type == MOUSEBUTTONDOWN:
			pass
				#import asteroids
				#return asteroids.Game(self.game)
			
