'''Simple data loader module.

Loads data files from the "data" directory shipped with a game.

Enhancing this to handle caching etc. is left as an exercise for the reader.
'''

import os
import pygame

#data_py = os.path.abspath(os.path.dirname(__file__))
#data_dir = os.path.normpath(os.path.join(data_py, '..', 'data'))
data_dir = 'data'
data_image_dir = 'images'
dialog_dir = 'dialogs'

def filepath(filename):
    '''Determine the path to a file in the data directory.
    '''
    return os.path.join(data_dir, filename)

def load(filename, mode='rb'):
    '''Open a file in the data directory.

    "mode" is passed as the second arg to open().
    '''
    return open(os.path.join(data_dir, filename), mode)

def loadImage(filename):
	return pygame.image.load(os.path.join(data_dir,data_image_dir, filename)).convert_alpha()

def loadMusic(filename):
	pygame.mixer.music.load(os.path.join(data_dir, filename))
	
def loadDialog(filename):
	return open(os.path.join(data_dir, dialog_dir, filename), 'r')

def loadSound(filename):
	return pygame.mixer.Sound(os.path.join(data_dir, filename))
