import pygame
from globalvars import *

class Level(engine.State):
	def __init__(self, game):
		self.game = game
		self.background = pygame.image.load(os.path.join("data","images", "<background-image>.png")).convert()

		if self.game.sound:
			pygame.mixer.music.load(os.path.join("data","music", "<soundfile.ogg/.wav"))
			
		#asteroid = [velocity, size, spinSpeed, resourcePayout]
		# The game can randomly choose the asteroid type, and by doing so will spit out the apropriate resource when the asteroid is destroyed
		self.asteroids = [astersoid]

	
	def musicStop(self):
		if self.game.sound:
			pygame.mixer.music.stop() #Stop music

	def musicPlay(self):
		if self.game.sound:
			pygame.mixer.music.play(-1) #Loop music
			
	def getLevelData(self):
		return self.background, self.asteroids