import globalvars
from globalvars import *
from util import *

#from globalvars import systems

# global systems

# Base Classes

class Location:
	name 	= "defaultName"
	image 	= "test.png"
	pos 	= (0,0)
	desc 	= "This space for rent"
	systemsObj = None


class AsteroidField(Location):
	resourceType	= "Ore"
	avgSpeed		= 100
	avgSpin			= 10
	initRockSizes		= [ 0, 0, 0, 0, 0, 0, 0, 0, ]
	initMineralSizes	= [ 0, 0, 0, 0, 0, 0, 0, 0, ]
	initOreSizes		= [ 0, 0, 0, 0, 0, 0, 0, 0, ]
	initWaterSizes		= [ 0, 0, 0, 0, 0, 0, 0, 0, ]
	payoutProbability	= 1
	atmosphere	= ""
	gravity		= 0
	yearLen		= 0
	canTravel			= False


class Planet(Location):
	demand = [ 1, 1, 1, 1 ]
	capacity = 10
	stock = [ 0, 0, 0, 0 ]
	atmosphere = ""
	gravity = 1
	yearLen = 365
	primaryExport = ""
	items = {}
	visited = False
	canTravel	= False


	# Adds an item able to be bought at this location
	def addItem(item,buyMultiplier):
		self.items[item.__class__] = (item,buyMultiplier)
	addItem = Callable(addItem)


class System:
	name = "Generic System Name"
	locations = {}
	locationsList = []
	
	
	def __init__(self,name):
		self.name = name
	
	def add(self,location):
	
		self.locations[location.name] = location
		self.locationsList.append(location)
		# Is it really necessary to do galaxy-wide tracking on planet names?
		Galaxy.locationSystem[location.name] = self
		#systems = Systems()
		#systems.locationSystem[location.name] = self
		return self
		
	def getLocation(self,fieldOrPlanetName):
		print "Getting location of " + fieldOrPlanetName
		
		if not self.locations[fieldOrPlanetName]: raise MissingFieldOrPlanet, fieldOrPlanetName
		return self.locations[fieldOrPlanetName]


class Galaxy:
	systems = {}
	systemsList = []
	locationSystem = {}
	
	def add(system):
		Galaxy.systems[system.name] = system
		Galaxy.systemsList.append(system)

	def getLocation(fieldOrPlanetName):
		try:
			if not Galaxy.locationSystem[fieldOrPlanetName]: return None
		except KeyError:
			return None
		return Galaxy.locationSystem[fieldOrPlanetName].getLocation(fieldOrPlanetName)

	getLocation = Callable(getLocation)
	

"""	
class Systems:
	def __init__(self):
		self.systems = {}
		self.systemsList = []
		self.locationSystem = {}
	
	def add(self,system):
		system.setSystemsObj(self)
		self.systems[system.name] = system
		self.systemsList.append(system)
		return self
	
	def getLocation(self,fieldOrPlanetName):
		if not self.locationSystem[fieldOrPlanetName]: raise MissingFieldOrPlanet, fieldOrPlanetName
		self.locationSystem[fieldOrPlanetName].getLocation(fieldOrPlanetName)

	def getSystem(self,systemName):
		return self.systems[systemName]
	"""


####################################################################
#                                                                  #
#                  Start of Location Descriptions                  #
#                                                                  #
####################################################################

	
class KV14(Planet):
	name		= "KV14"
	pos 		= (471,410)
	demand		= (.4, .6, .8, .7)
	capacity 	= 10
	stock		= (5, 2, 1, 2)
	atmosphere	= "Sulfur Dioxide"
	gravity		= 7.457
	yearLen		= 0.928
	primaryExport	= "Minerals"
	image		= "planet1.png"
	desc		= ["A mining colony"," "]
	canTravel	= True
	asteroid	= False
	
class KV27(Planet):
	name		= "KV27"
	pos 		= (253,348)
	demand		= (.6, .2, .8, .6)
	capacity 	= 25
	stock		= (4, 17, 3, 12)
	atmosphere	= "Carbon Monoxide"
	gravity		= 10.422
	yearLen		= 4.115
	primaryExport	= "Ore"
	image		= "planet2.png"
	desc		= ["Ore Processing","Plant"]
	asteroid	= False

class KVA49(AsteroidField):
	name			= "KVA49"
	image			= "asteroid_field.png"
	pos				= (576,422)
	desc			= "KVA50 is named", "after the letters", "K, V, and A, and", "the number 50."
	resourceType	= "Minerals"
	avgSpeed		= 100
	avgSpin			= 5
	initRockSizes		= [ 0, 0, 3, 0, 1, 0, 0, 0, ]
	initMineralSizes	= [ 0, 3, 2, 3, 0, 0, 0, 0, ]
	initOreSizes		= [ 0, 0, 0, 0, 0, 0, 0, 0, ]
	initWaterSizes		= [ 0, 0, 0, 0, 0, 0, 0, 0, ]
	payoutProbability	= 1
	asteroid	= True
	
class KVA50(AsteroidField):
	name			= "KVA50"
	image			= "asteroid_field.png"
	pos				= (588,342)
	desc			= "The primary", "ore harvesting", "field for", "this sector."
	resourceType	= "Ore"
	avgSpeed		= 100
	avgSpin			= 5
	initRockSizes		= [ 0, 0, 1, 2, 1, 0, 0, 0, ]
	initMineralSizes	= [ 0, 1, 0, 0, 0, 0, 0, 0, ]
	initOreSizes		= [ 3, 4, 2, 0, 0, 0, 0, 0, ]
	initWaterSizes		= [ 0, 0, 0, 0, 0, 0, 0, 0, ]
	payoutProbability	= 1
	asteroid	= True
	
class KVA51(AsteroidField):
	name			= "KVA51"
	image			= "asteroid_field.png"
	pos				= (148,374)
	desc			= "Right at the", "overlap of both", "the ore laden", "and mineral", "heavy sections", "of the field."
	resourceType	= "Minerals / Ore"
	avgSpeed		= 100
	avgSpin			= 10
	initRockSizes		= [ 0, 0, 3, 3, 1, 0, 0, 0, ]
	initMineralSizes	= [ 0, 1, 3, 0, 0, 0, 0, 0, ]
	initOreSizes		= [ 0, 3, 1, 0, 0, 0, 0, 0, ]
	initWaterSizes		= [ 0, 0, 0, 0, 0, 0, 0, 0, ]
	payoutProbability	= 1
	asteroid	= True
	canTravel	= True
	
class KV68(Planet):
	name		= "KV68"
	pos 		= (224,443)
	demand		= (.2, .7, .6, .4)
	capacity 	= 20
	stock		= (14, 7, 15, 12)
	atmosphere	= "Hydrogen Peroxide"
	gravity		= 10.422
	yearLen		= 44.894
	primaryExport	= "Minerals"
	image		= "planet3.png"
	desc		= ["Mineral", "Processing","Plant"]
	asteroid	= False
	
class KV69(Planet):
	name		= "KV69"
	pos 		= (720,389)
	demand		= (.2, .8, .6, .8)
	capacity 	= 30
	stock		= (27, 7, 22, 27)
	atmosphere	= "Fine Dust"
	gravity		= 4.323
	yearLen		= 17.025
	primaryExport	= "Minerals"
	image		= "planet2.png"
	desc		= ["Mineral", "Processing","Plant"]
	asteroid	= False
	
class KV112(Planet):
	name		= "KV112"
	pos 		= (65,372)
	demand		= (.5, .5, .7, .6)
	capacity 	= 10
	stock		= (2, 2, 2, 10)
	atmosphere	= "Fine Dust"
	gravity		= 4.323
	yearLen		= 17.025
	primaryExport	= "Minerals"
	image		= "planet4.png"
	desc		= ["Research Center"]
	asteroid	= False
	
Galaxy.systems["KappaFive"] = System("KappaFive")
Galaxy.systems["KappaFive"].add(KV14)
Galaxy.systems["KappaFive"].add(KV27)
Galaxy.systems["KappaFive"].add(KVA49)
Galaxy.systems["KappaFive"].add(KVA50)
Galaxy.systems["KappaFive"].add(KVA51)
Galaxy.systems["KappaFive"].add(KV68)
Galaxy.systems["KappaFive"].add(KV69)
Galaxy.systems["KappaFive"].add(KV112)

