'''Game main module.

Contains the entry point used by the run_game.py script.

Feel free to put all your game code here, or in other modules in this "lib"
directory.
'''
import data
import os
import pygame
import cPickle as pickle
from pygame.locals import *

from globalvars import *

from pgu import engine
from pgu import timer

def saveGameData(data):
	savePath = os.path.join(os.path.expanduser("~"),'.rogerrobot')
	f = open(savePath, 'w')
	pickle.dump(data, f)
	f.close()
	
def loadGameData():
	savePath = os.path.join(os.path.expanduser("~"),'.rogerrobot')
	f = open(savePath, 'r')
	data = pickle.load(f)
	f.close()
	return data

class Game(engine.Game):
	def init(self):
		self.timer = timer.Timer(FPS)
		self.mode = 0
        	self.screen = pygame.display.set_mode((screenWidth,screenHeight),self.mode)
		self.musicPlaying = None
        	pygame.font.init()
        	try:
            		pygame.mixer.init()
            		self.sound = True
        	except:
            		self.sound = False
        	pygame.display.set_caption("Roger Robot")
		pygame.display.set_icon(data.loadImage("BiNoc1.png"))
        	self.music = 1
		
		self.playCredits = False
		self.cutsceneNumber = 1
		self.playIntro = True
		self.skipTradingScreen = False
		self.tradeResources = {"cash":100, "fuel":100, "shipUpgrades":[]}
		self.saveData = {"sounds":self.sound}
		
		if os.path.exists(os.path.join(os.path.expanduser("~"),'.rogerrobot') ):
			self.saveData = loadGameData()
			self.sound = self.saveData["sounds"]
			print self.saveData
		else:
			saveGameData(self.saveData)

    	def tick(self):
        	self.timer.tick()
		
    	def event(self,e):
        	if e.type is QUIT:
            		self.state = engine.Quit(self)
            		return 1
			
        	if e.type is KEYDOWN and e.key == K_F10:
            		tmp = pygame.Surface((screenWidth,screenHeight)).convert()
            		tmp.blit(self.screen,(0,0))
            		self.mode ^= FULLSCREEN
            		self.screen = pygame.display.set_mode((screenWidth,screenHeight),self.mode)
            		self.screen.blit(tmp,(0,0))
            		pygame.display.flip()
            		return 1
        
        	if e.type is KEYDOWN and e.key == K_F2:
            		if self.sound:
                		self.music ^= 1
				self.sound = False
                		pygame.mixer.music.set_volume(self.music)
			else:
				self.sound = True
				
			self.saveData["sounds"] = self.sound	
			saveGameData(self.saveData)
            		return 1

def main():
	g = Game()

	import menu
	#import asteroids
	#import game
	g.run(menu.Menu(g))
	#g.run(asteroids.Game(g))
	#g.run(game.NavUI(g))
	#g.run(menu.Highs(g))

	pygame.quit()

#def main():
	#print "Hello from your game's main()"
	#print data.load('sample.txt').read()
