import pygame
from pygame.locals import *
import data
from data import *
import random

import os
from globalvars import *
from textrect import *
from game import Button
from game import Planet


from pgu import engine
class Menu(engine.State):
	def __init__(self,game):
		self.game = game
		
		
	def init(self):
		if self.game.sound:
			self.clickSound = loadSound("button-click.ogg")
			if self.game.musicPlaying != "menu":
				pygame.mixer.music.fadeout(500)
				
				loadMusic("song01.ogg")
				pygame.mixer.music.play(-1)
				
				self.game.musicPlaying = "menu"
		else:
			self.clickSound = None
				
		self.quit = False
		self.cur = 0
		self.menu = ['play','about', 'introduction', 'quit']
	
		playImage = loadImage("play_button.png")
		creditsImage = loadImage("credits_button.png")
		quitImage = loadImage("quit_button.png")

		self.x = (screenWidth-playImage.get_width())/2
		y = 430
				
		self.playButton = Button(playImage, [self.x, y], True)
		self.creditsButton = Button(creditsImage, [self.x, y+50], True)
		self.quitButton = Button(quitImage, [self.x, y+100], True)
		
		
		#self.banner = pygame.image.load(os.path.join("data","images", "background.png")).convert()
		self.background = loadImage("splash_backdrop1.png")
		#self.logo = pygame.image.load(os.path.join("data","logo.png")).convert_alpha()
		
		self.planet = loadImage("planet2.png")
		self.planet2 = loadImage("planet5.png")
		
		self.robot = loadImage("BiNoc1.png")
		self.zones = []
		
	def loop(self):
		if self.playButton.release:
			if self.clickSound != None:
				self.clickSound.play(0)
				
			if self.game.playIntro == True:
				import globalvars
				#self.game.playIntro = False
				curPlanet = ["Planet", True]
				planets = [ Planet(loadImage("planet1.png"), (-450, -400), True, "Opening")]
				import cutscene
				self.game.skipTradingScreen = True
				return cutscene.CutsceneUI(self.game, globalvars.story.getSceneOnEntry("Opening"), curPlanet, planets)
			
			else:
				import game
				return game.NavUI(self.game)
			#return BackStory(self.game)
		
		if self.creditsButton.release:
			if self.clickSound != None:
				self.clickSound.play(0)
				
			curPlanet = ["Credits", True]
			planets = [ Planet(loadImage("planet1.png"), (450, 400), True, "Credits")]
			import cutscene
			self.game.playCredits = True
			return cutscene.CutsceneUI(self.game, story.getSceneOnEntry(curPlanet[0]), curPlanet, planets)
		
		if self.quitButton.release:
			if self.clickSound != None:
				self.clickSound.play(0)
			return engine.Quit(self.game)
		
			
			
	def update(self,screen):
		return self.paint(screen)

	def paint(self,screen):
		#screen.fill((0,0,0))
		screen.blit(self.background, (0,0))
		#img = self.banner
		
		#screen.blit(self.banner,(0,0))
		screen.blit(self.planet, (-100,500))
		screen.blit(self.planet2, (660,250))
		screen.blit(self.robot, (self.x+10, 325))
		
			
		self.playButton.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
		self.creditsButton.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
		self.quitButton.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])

		pygame.display.flip()
		
	def event(self,e):
		pass
		
			
		#if (e.type is KEYDOWN and e.key in (K_RETURN,K_ESCAPE)) or (e.type is MOUSEBUTTONDOWN):
			#val = self.menu[self.cur]
			#if e.type is KEYDOWN and e.key == K_ESCAPE:
				#return engine.Quit(self.game)

			#if val == "play":
				#import game
				#return game.NavUI(self.game)
				
			#if val == "quit":
				#return engine.Quit(self.game)
			
			#if val == "introduction":
				#return BackStory(self.game)
			##if val == "about":
				##return About(self.main)
				
class BackStory(engine.State):
	def __init__(self,game):
		self.game = game
		
		if self.game.sound:
			self.clickSound = loadSound("button-click.ogg")
			if self.game.musicPlaying != "menu":
				pygame.mixer.music.fadeout(500)
				
				loadMusic("song01.ogg")
				pygame.mixer.music.play(-1)
				
				self.game.musicPlaying = "menu"
		else:
			self.clickSound = None
				
		self.quit = False
		self.cur = 0
		
	
		nextImage = loadImage("next_button.png")
		skipImage = loadImage("skip_button.png")

		self.x = ((screenWidth-nextImage.get_width())/2) - 50
		y = 270
				
		self.skipButton = Button(skipImage, [self.x, 550], True)
		self.nextButton = Button(nextImage, [self.x+105, 550], True)
			
		#self.banner = pygame.image.load(os.path.join("data","images", "background.png")).convert()
		self.background = pygame.image.load(os.path.join("data","images", "space_backdrop1.png")).convert()

		#self.logo = pygame.image.load(os.path.join("data","logo.png")).convert_alpha()
		
		self.planet = loadImage("planet2.png")

		self.planet2 = loadImage("planet5.png")

		
		
	def loop(self):		
		if self.nextButton.release:
			if self.clickSound != None:
				self.clickSound.play(0)
				
			return BackStoryMore(self.game)
				
		if self.skipButton.release:
			if self.clickSound != None:
				self.clickSound.play(0)
			
			import game
			return game.NavUI(self.game)
				
			#return engine.Quit(self.game)
			
	def update(self,screen):
		return self.paint(screen)
	
	def TextBox(self,screen, text, pos):
		font = pygame.font.Font(os.path.join("data","Wanta.ttf"),15)
		textRect = pygame.Rect(pos, (575,175))
		renderedText = render_textrect(text, font, textRect, (0,0,0), 0)
		screen.blit(renderedText, textRect.topleft)

	def paint(self,screen):
		#screen.fill((0,0,0))
		
		screen.blit(self.background, (0,0))

		
		text1 = """At the pinnacle of human civilization, the achievements of mankind were numerous and amazing, probing the very oracles of the universe. They made machines that could fashion anything; machines that could answer their most challenging questions; machines that could replicate and work in deep space However, all these achievements, and the fate of the human race were put in serious peril the day the Linear-1541 asteroid was identified and computed to collide with the Earth in a mere twenty months."""
		
		text2 = """The World Council was notified of the impending disaster and a plan of\naction was drafted and hope was restored. The plan was fully detailed,\ntaking advantage of the most advanced technology and covering every possible scenario. Included in its vast information was the age-old contingency plan called C-Seventeen; the plan to use if all else failed. It\nwas this plan that would be executed on the fateful day. C-Seventeen detailed the following scenario: A diverse sampling of Earth's inhabitants"""
		
		text3 = """would be put in cryogenic stasis and transported to the Inner Core Laboratory deep within the heart of the planet. while lunar station Alpha would actively monitor Earth. If an extinction level event occurred, Alpha would radio the asteroid and kuiperbelt mining robots and activate the old, latent\n"C-Seventeen program."""
		
		self.TextBox(screen, text1, (10,10))
		self.TextBox(screen, text2, (45,190))
		self.TextBox(screen, text3, (95,370))
		
		screen.blit(self.planet, (-100,500))
		screen.blit(self.planet2, (660,250))
			
		self.nextButton.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
		self.skipButton.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])

		pygame.display.flip()
		
	def event(self,e):
		if e.type is KEYDOWN and e.key == K_ESCAPE:
			import game
			return game.NavUI(self.game)

		
class BackStoryMore(engine.State):
	def __init__(self,game):
		self.game = game
		
		if self.game.sound:
			self.clickSound = loadSound("button-click.ogg")
			if self.game.musicPlaying != "menu":
				pygame.mixer.music.fadeout(500)
				
				loadMusic("song01.ogg")
				pygame.mixer.music.play(-1)
				
				self.game.musicPlaying = "menu"
		else:
			self.clickSound = None
				
		self.quit = False
		self.cur = 0
		
	
		playImage = loadImage("play_button.png")

		self.x = ((screenWidth-playImage.get_width())/2)
		y = 270
				
		self.playButton = Button(playImage, [self.x, 550], True)
		
			
		#self.banner = pygame.image.load(os.path.join("data","images", "background.png")).convert()
		self.background = pygame.image.load(os.path.join("data","images", "space_backdrop1.png")).convert()

		#self.logo = pygame.image.load(os.path.join("data","logo.png")).convert_alpha()
		
		self.planet = loadImage("planet2.png")

		self.planet2 = loadImage("planet5.png")

		
		
	def loop(self):		
		if self.playButton.release:
			if self.clickSound != None:
				self.clickSound.play(0)
				
			import game
			return game.NavUI(self.game)
				
			
	def update(self,screen):
		return self.paint(screen)
	
	def TextBox(self,screen, text, pos):
		font = pygame.font.Font(os.path.join("data","Wanta.ttf"),15)
		textRect = pygame.Rect(pos, (575,175))
		renderedText = render_textrect(text, font, textRect, (0,0,0), 0)
		screen.blit(renderedText, textRect.topleft)

	def paint(self,screen):
		#screen.fill((0,0,0))
		
		screen.blit(self.background, (0,0))

		
		text1 = """Along with the their usual tasks of mining ore and ice from asteroids, the C-Seventeen program would guide the robots to form communities, research\nand build inter-stellar transportation to seek out suitable planetary systems and ultimately terraform a new world for mankind to inhabit. When the right kinds of inputs were activated, the program would activate again guiding\nthe robots home to Earth to fetch the remnant of mankind lying deep in the Earth."""
		
		text2 = """Thousands of years have passed since the C-Seventeen program was\nactivated. Over that period of time the robots have grown into a race of their own. They have accomplished many technological advances to complete their program objectives and using a robot created space-folding drive, several suitable systems were found in a neighboring galaxy and the terraforming process was begun."""
		
		text3 = """Yet, while the program tasks of mining and terraforming have become woven into the fabric of robot civilization, the purpose has been lost. In fact, the notion of humans is thought to be a myth; a cleverly crafted story to give comfort to those who need a purpose for existence..."""
		
		self.TextBox(screen, text1, (10,10))
		self.TextBox(screen, text2, (45,190))
		self.TextBox(screen, text3, (95,370))
		
		screen.blit(self.planet, (-100,500))
		screen.blit(self.planet2, (660,250))
			
		self.playButton.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
		#self.skipButton.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])

		pygame.display.flip()
		
	def event(self,e):
		if e.type is KEYDOWN and e.key == K_ESCAPE:
			import game
			return game.NavUI(self.game)