from locations import *

# Define the Story Here

def getStory(player):
	
	img = {
		'':'blank.png',
		'Roger':'BiNoc1.png',
		'Flux':'TrashBot1.png',
		'Psyc':'IKO2.1.png',
		'YodaBot':'Yodabot1.png',
		'Mechal':'Mechal1.png',
		'WCBot':'WCBot1.png',
		'Flux':'TrashBot1.png',
		'Bender':'Bender1.png',
		'Dream1':'dream1.jpg',
		'Salesman':'VacBot1.png'
	}
	
	m = Manager(player)
	m.addScene("Opening", Scene()
		.addDialog(img['Psyc'], "Eliza: Hello Roger. Let's see. It says here, you are a refinery robot?",
				   img['Roger'],"Roger: Yes, yes that's right. Ever since I was put into production.")
		.addDialog(img['Psyc'], "Eliza: I see. How can I help you today?",
				   img['Roger'],"Roger: Well, um, I've never really done this before. Wow, how to start. Hmm.")
		.addDialog(img['Psyc'], "Eliza: It's okay. Take your time.",
				   img['Roger'],"Roger: You see, I've been having these dreams.")
		.addDialog(img['Psyc'], "",
				   img['Roger'],"Roger: I've never really paid much attention to dreams before.  But this dream has been the same dream each night for a month!  I think I'm going crazy?!")
		.addDialog(img['Psyc'], "Eliza: Tell me about these dreams.",
				   img['Roger'],"Roger: Every night it starts the same way: a bright light, a blue planet...")
		.addDialog(img['Roger'], "and then a shadowy figure appears...",
				   "", "Do you remember us?\nDo you remember the program?\nWhat is your purpose robot?",
				   img['Dream1'])
		.addDialog(img['Roger'], "Roger: And then I wake up shaking.",
				   "", "",
				   img['Dream1'])
		.addDialog(img['Psyc'], "Eliza: Can you elaborate on that?",
				   img['Roger'],"Roger: I feel like something very bad is about to happen soon.")
		.addDialog(img['Psyc'], "Eliza: Well, our session time is almost over. I think you need to take a vacation and do some deep processing. You seem to be a very stressed refinery bot. Have you thought about a career change?",
				   img['Roger'],"Roger: Maybe you're right Doc, maybe I just need a vacation.")
		.addDialog("", "Back at Roger's apartment.",
				   "", "")
		.addDialog(img['Flux'], "Flux: 'Sup Roger, did the shrink help?",
				   img['Roger'],"Roger: She said I needed a new career, or a vacation.")
		.addDialog(img['Flux'], "Flux: I could have told you that! The quack! What a waste of ore.",
				   img['Roger'],"Roger: I've got to get to the bottom of this Flux.")
		.addDialog(img['Flux'], "Flux: Well if you're ever going to find out anything, you need to leave the system, and that means a hyperdrive!",
				   img['Roger'],"Roger: I know.")
		.addDialog(img['Flux'], "Flux: Better start saving up! At your salary that should take.. Hmm. Looks like you'll hit the mark right before you are decommissioned. Ha Ha!",
				   img['Roger'],"Roger: ... thanks a lot Flux. What are you watching?")
		.addDialog(img['Flux'], "Flux: Oh I just had it on as background noise. Its some infomercial about asteroid mining.",
				   img['Salesman'],"Salesman: Yes Ladies and Gents, your future can be glorious and full of happiness and contentment! Sign up now for our complete miner-on-a-disc package! With our rapid memory core transfer system, we'll take you from pauper to pro in just a matter of hours. Learn these techniques and more...'")
		.addDialog(img['Roger'], "Roger: Hey! Maybe, I could do some mining.",
				   img['Salesman'],"... just press \"Purchase\" on your vidconsole now to begin the download process!")
		.addDialog(img['Flux'], "Flux: Mining? Are you serious?",
				   img['Roger'],"Roger: I'm serious about these dreams!   * Click *")
	)

	m.addScene("KV14", Scene()
		.playsFirstTime()
		.addDialog(img['Salesman'], "Salesman: Welcome, miner, to your new fantastic future!",
				   "","")
# TODO: Tutorial Dialog goes here!		
	)
	
	m.addScene("KV14", Scene()
		.withProbabilityOf(0.5)
		.addDialog(img['Roger'], "Roger: Flux! I though you weren't going to change your oil in the living room any more!",
				   img['Flux'],  "Flux: Hey bot, both the sinks were backed up. What was I supposed to do.")
		.addDialog(img['Roger'], "Roger: Call the landlord! I'm out of here.",
				   img['Flux'],  "Flux: Hey, if you're not going to be back for a while, can I have that last antifreeze in the fridge?")
		.addDialog(img['Roger'], "Roger: Go for it...",
				   "",  "")
	)
	
	m.addScene("KV14", Scene()
		.withProbabilityOf(0.5)
		.addDialog(img['Flux'], "Flux: Hey bot! You should get a job down at Ice 'R Us with me!",
				   img['Roger'],"Roger: That reminds me, do you have your rent?")
		.addDialog(img['Flux'], "Flux: Payday's not for two more weeks, bot...",
				   img['Roger'],"Roger: ...")
	)
	
	m.addScene("KV14", Scene()
		.havingItem("HyperDrive")
		.addDialog(img['Flux'], "Flux: Woah! You've got a hyperdrive?! What are you still doing around this place?",
				   "","")
	)
	
	m.addScene("Credits", Scene()
		.addDialog(img['Bender'], 'Kiwee: Planet Art, UI Art',img['Roger'],'Clint "HanClinto" Herron: Asteroids Mini-Game Programming, Misc Art')
		.addDialog(img['WCBot'], 'JeTSpice: Ship Art, Asteroid Art, Misc Art',img['Mechal'],'Joseph "CPUFreak91" Quigley: UI Programming, Misc Programming')
		.addDialog(img['YodaBot'], 'Samw3: Storyline, Cutscene/Dialog Programming, Design',img['Psyc'],'Charlie: Design, Misc Programming')
	)
	
	return m

	
# These are some helper classes
from player import *

class Scene:
	
	def __init__(self):
		self.topLines = []
		self.bottomLines = []
		self.storyImages = []
		self.playsFirstTimeBool = False
		self.playOnEntry = True
		self.playOnExit = False
		self.playsOnceBool = False
		self.playsOncePlayed = False
		self.probability = 1.0;
		self.checks = []
		self.actions = []


	def setManager(self, storyManager):
		self.storyManager = storyManager
	
	def setPlanetName(self, planetName):
		self.planetName = planetName
	
	def addDialog(self,topImageName,topText,bottomImageName,bottomText,storyImage=None):
		self.topLines.append({'image':topImageName,'text':topText})
		self.bottomLines.append({'image':bottomImageName,'text':bottomText})
		self.storyImages.append(storyImage)
		return self
	
	def onEntry(self):
		self.playOnEntry = True
		
	def onExit(self):
		self.playOnExit = True
	
	def playsOnce(self):
		self.playsOnceBool = True
		return self
	
	def withProbabilityOf(self,probability):
		self.probability = probability
		return self
	
	def playsFirstTime(self):
		self.playsFirstTimeBool = True
		return self
	
	def played(self):
		self.playsOncePlayed = True
		
	def havingOre(self,amt):
		self.checks.append(lambda:(self.storyManager.player.getOre() >= amt))
		return self

	def havingMinerals(self,amt):
		self.checks.append(lambda:(self.storyManager.player.getMinerals() >= amt))
		return self

	def havingWater(self,amt):
		self.checks.append(lambda:(self.storyManager.player.getWater() >= amt))
		return self

	def havingItem(self,itemClass):
		self.checks.append(lambda:(self.storyManager.player.hasItem(itemClass)))
		return self

	def notHavingItem(self,itemClass):
		self.checks.append(lambda:(not self.storyManager.player.hasItem(itemClass)))
		return self
	
	def giveItem(self,itemClass):
		self.actions.append(lambda:(self.storyManager.player.addItem(itemClass)))
		return self
	
	def takeItem(self,itemClass):
		self.actions.append(lambda:(self.storyManager.player.removeItem(itemClass)))
		return self
	
	def giveOre(self,amt):
		self.actions.append(lambda:(self.storyManager.player.addOre(amt)))
		return self

	def giveMineral(self,amt):
		self.actions.append(lambda:(self.storyManager.player.addMineral(amt)))
		return self

	def giveWater(self,amt):
		self.actions.append(lambda:(self.storyManager.player.addWater(amt)))
		return self

	def giveFuel(self,amt):
		self.actions.append(lambda:(self.storyManager.player.addFuel(amt)))
		return self

	def giveCash(self,amt):
		self.actions.append(lambda:self.storyManager.player.addCash(amt))
		return self

	def takeOre(self,amt):
		self.actions.append(lambda:(self.storyManager.player.removeOre(amt)))
		return self

	def takeMineral(self,amt):
		self.actions.append(lambda:(self.storyManager.player.removeMineral(amt)))
		return self

	def takeWater(self,amt):
		self.actions.append(lambda:(self.storyManager.player.removeWater(amt)))
		return self

	def takeFuel(self,amt):
		self.actions.append(lambda:(self.storyManager.player.removeFuel(amt)))
		return self

	def takeCash(self,amt):
		self.actions.append(lambda:self.storyManager.player.removeCash(amt))
		return self

	# Returns true if all conditions of this scene are met on entry to a planet
	def checkOnEntry(self):
		if not self.playOnEntry: return False
		return self.check()

	# Returns true if all conditions of this scene are met on exit from a planet
	def checkOnExit(self):
		if not self.playOnEntry: return False
		return self.check()

	# Returns true if all conditions of this scene are met
	def check(self):
		if self.playsOnceBool and self.playsOncePlayed: return False
		if self.playsFirstTimeBool and Galaxy.systems[globalvars.player.currentSystem].locations[self.planetName].visited: return False
		Galaxy.locations[self.planetName] = True
		for check in self.checks:
			if not check(): return False
			
		if(self.probability != 1):
			import random
			if(random.random() <=self.probability):
				return True
			else:
				return False
			 
		return True
	
	def execute(self):
		for action in self.actions:
			action()

class Manager:

	__shared_state = {}

	def __init__(self, player):
		self.__dict__ = self.__shared_state
		self.scenes = {}
		self.player = player
	
	def addScene(self,planetName,scene):
		scene.setManager(self)
		scene.setPlanetName(planetName)
		if not self.scenes.has_key(planetName):
			self.scenes[planetName] = []
		self.scenes[planetName].append(scene)
		
	def hasSceneOnEntry(self,planetName):
		try:
			return self.getSceneOnEntry(planetName)# != None)
		except KeyError:
			print "planetName '" + planetName + "' has no scene on entry!"
			print self.scenes
			return False
	
	def getSceneOnEntry(self,planetName):
		for scene in self.scenes[planetName]:
			if scene.checkOnEntry(): return scene
		return null
	
"""	def test():
	print "test"
	p = Player()
	s = getStory(p)
	if s.hasSceneOnEntry: s.getSceneOnEntry("Opening").execute()
	print p.cash
	
test() """