# My trade.py UI shall take over the world... or at least give all the bots in this game DDoS :D -- Joe

import os

import pygame
import ode
#import math

import random
import asteroids

from globalvars import *
from pgu import engine
from pgu import timer
from data import *
from pygame.locals import *
from game import *
import game
import tradeUtil
#from player import Player as player
#import player

class TradeUI(engine.State):	
	def __init__(self, game, heavenlyBodies, curPlanet):
		self.game = game
		self.heavenlyBodies = heavenlyBodies
		self.curPlanet = curPlanet
		
		for bodyKey in self.heavenlyBodies:
			body = self.heavenlyBodies[bodyKey]
			if body.name == self.curPlanet[0]:
				self.curPlanet[1] = body.image
		
	#def __init__(self, game):
		#self.game = game
		#self.cutScene = 0
		
	def init(self):
		if self.game.sound:
			self.clickSound = loadSound("button-click.ogg")
			if self.game.musicPlaying != "nav":
				pygame.mixer.music.fadeout(900)
				
				loadMusic("song09.ogg")
				pygame.mixer.music.play(-1)
				
				self.game.musicPlaying = "nav"
				
		else:
			self.clickSound = None
		
		
		self.fuelImg = loadImage("resource_fuel_1.png")
		self.oreImg = loadImage("resource_ore_1.png")
		self.mineralsImg = loadImage("resource_minerals_1.png")
		self.waterImg = loadImage("resource_water_1.png")
		
		self.fuelImgSmall = pygame.transform.scale(self.fuelImg, (self.fuelImg.get_width() -45, self.fuelImg.get_height() -45))
		self.oreImgSmall = pygame.transform.scale(self.oreImg, (self.oreImg.get_width() -45, self.oreImg.get_height() -45))
		self.mineralsImgSmall = pygame.transform.scale(self.mineralsImg, (self.mineralsImg.get_width() -45, self.mineralsImg.get_height() -45))
		self.waterImgSmall = pygame.transform.scale(self.waterImg, (self.waterImg.get_width() -45, self.waterImg.get_height() -45))
		
		#screen.blit(self.fuelImg, (20, 240))
		#screen.blit(self.oreImg, (20, 290))
		#screen.blit(self.waterImg, (20, 340))
		#screen.blit(self.mineralsImg, (20, 390))
		
		self.fuel = player.getFuel
		self.ore = player.getOre
		self.water = player.getWater
		self.mineral = player.getMineral
		
		self.mineralBuyPrice = None
		self.fuelBuyPrice = None
		self.waterBuyPrice = None
		self.oreBuyPrice = None
		
		
			
		for bodyKey in self.heavenlyBodies:
			body = self.heavenlyBodies[bodyKey]
			if body.asteroid == False:
				if self.curPlanet[0] == body.name:
					self.mineralBuyPrice = tradeUtil.getMineralBuyPrice(body)
					self.fuelBuyPrice = tradeUtil.getFuelBuyPrice(body)
					self.waterBuyPrice = tradeUtil.getWaterBuyPrice(body)
					self.oreBuyPrice = tradeUtil.getOreBuyPrice(body)
					
		
		
		
		self.buyResourceButtons = {
		"Fuel":(game.Button(self.fuelImgSmall, [20, 280], True), [20, 280], "Fuel" ),
		"Ore":(game.Button(self.oreImgSmall, [20, 330], True), [20, 330], "Ore" ),
		"Water":(game.Button(self.waterImgSmall, [20, 380], True), [20, 380], "Water" ),
		"Minerals":(game.Button(self.mineralsImgSmall, [20, 430], True), [20, 430], "Minerals" )
		}
		
		#print player.getOre()
		
		self.sellResourceButtons = {
		"Fuel":(game.Button(self.fuelImgSmall, [525, 280], True), [525, 280], "Fuel" ),
		"Ore":(game.Button(self.oreImgSmall, [525, 330], True), [525, 330], "Ore" ),
		"Water":(game.Button(self.waterImgSmall, [525, 380], True), [525, 380], "Water" ),
		"Minerals":(game.Button(self.mineralsImgSmall, [525, 430], True), [525, 430], "Minerals")
		}
		
		self.backButton = game.Button(loadImage("back_button.png"), [10, 550], True)
		
		#self.buyOreButton = game.Button(loadImage("buy_button.png"), [400, 300], True)
		#self.sellOreButton = game.Button(loadImage("sell_button.png"), [400, 345], True)
		
		self.background = loadImage("space_backdrop1.png")
		self.planetDescBackground = loadImage("trade_hud_planet_desc.png")
		self.tradeItemsBackground = loadImage("trade_hud_items_bgkr.png")
		
	
	def loop(self):	
		if self.backButton.release:
			if self.clickSound != None:
				self.clickSound.play(0)
			return game.NavUI(self.game)
			
		for name in self.buyResourceButtons:
			button = self.buyResourceButtons[name][0]
			if button.release:
				if name == "Water":
					
					if player.cash >= self.waterBuyPrice:
						player.addWater(1)
						player.cash += self.waterBuyPrice
					
					
				if name == "Ore":
					if player.cash >= self.oreBuyPrice:
						player.addOre(1)
						player.cash += self.oreBuyPrice
						
				if name == "Fuel":
					
					if player.cash >= self.fuelBuyPrice:
						player.addFuel(1)
						player.cash += self.fuelBuyPrice
					
				if name == "Minerals":
					
					if player.cash >= self.mineralBuyPrice:
						player.addMineral(1)
						player.cash += self.mineralBuyPrice
					
					
				
		
	
	def update(self,screen):
		return self.paint(screen)
	
	def paint(self,screen):
		self.screen = screen
		#screen.fill((0,0,0))
		screen.blit(self.background, (0,0))
		
		try:
			screen.blit(self.curPlanet[1], (123,335))
			#screen.blit(self.curPlanet[1], (80,235))
		except TypeError:
			image = pygame.Surface((1, 1))
			image.fill((0, 0, 0))
			screen.blit(image, (-1,-1))
			
		
		for bodyKey in self.heavenlyBodies:
			body = self.heavenlyBodies[bodyKey]
			if body.asteroid == False:
				if body.name == self.curPlanet[0]:
					planetImage = loadImage(body.image)
					screen.blit(planetImage, (60,350))
		
		screen.blit(self.planetDescBackground, (0,0))
		screen.blit(self.tradeItemsBackground, (0,235))
		screen.blit(self.tradeItemsBackground, (515,235))
		
		#[20, 280], True),
		#game.Button(self.oreImgSmall, [20, 330], True),
		#game.Button(self.waterImgSmall, [20, 380], True),
		#game.Button(self.mineralsImgSmall, [20, 430], True)
		font = pygame.font.Font(os.path.join("data","Wanta.ttf"),25)
			
		sellTitle = font.render("Sell",1, (0,0,0))
		buyTitle = font.render("Buy",1, (0,0,0))
		
		screen.blit(buyTitle, (15, 240))
		screen.blit(sellTitle, (525, 240))
		
		for buttons in self.buyResourceButtons:
			button = self.buyResourceButtons[buttons][0]
			button.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
			name = font.render(buttons,1, (0,0,0))
			pos = self.buyResourceButtons[buttons][1]
			screen.blit(name, (pos[0]+60, pos[1]))
			
			
			resourceName = self.sellResourceButtons[buttons][2]
			if resourceName == "Water":
				amnt = player.getWater()			
			elif resourceName == "Ore":
				amnt = player.getOre()
			elif resourceName == "Fuel":
				amnt = player.getFuel()				
			elif resourceName == "Minerals":
				amnt = player.getMineral()
						
			resourceNum = font.render(str(amnt),1, (0,0,0))
			screen.blit(resourceNum, (pos[0]+200, pos[1]))
			
#			resourceNum = font.render(str(self.sellResourceButtons[buttons][2]),1, (0,0,0))
#			screen.blit(resourceNum, (pos[0]+200, pos[1]))
			
		
		for buttons in self.sellResourceButtons:
			button = self.sellResourceButtons[buttons][0]
			button.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
			name = font.render(buttons,1, (0,0,0))
			pos = self.sellResourceButtons[buttons][1]
			screen.blit(name, (pos[0]+60, pos[1]))

			# This next confusing line is where it calls the function to get the updated resource. Yes it's confusing. Let this be a lesson to not over-use tuples next time. :-P
			
			resourceName = self.sellResourceButtons[buttons][2]
			if resourceName == "Water":
				amnt = player.getWater()			
			elif resourceName == "Ore":
				amnt = player.getOre()
			elif resourceName == "Fuel":
				amnt = player.getFuel()				
			elif resourceName == "Minerals":
				amnt = player.getMineral()
						
			resourceNum = font.render(str(amnt),1, (0,0,0))
			screen.blit(resourceNum, (pos[0]+200, pos[1]))

			#resourceNum = font.render(str(player.getWater() ),1, (0,0,0))
			#print buttons[2]
			#print buttons[2]
			
			#print self.sellResourceButtons[buttons][2]
		
		
		
		
		
		font2 = pygame.font.Font(os.path.join("data","Wanta.ttf"),20)
		planetWelcome = font.render("Welcome to %s!" % self.curPlanet[0],1, (0,0,0))
		
		cash = font2.render("Cash: "+str(player.cash),1,(0,0,0))
		
		screen.blit(cash, (20, 160))
		screen.blit(planetWelcome, (20,6))
		
		
		x, y = 20, 40
		for bodyKey in self.heavenlyBodies:
			body = self.heavenlyBodies[bodyKey]
			if body.asteroid == False:
				if body.name == self.curPlanet[0]:
					newDesc = []
					#for line in body.desc:
						#newDesc.append(line)
					newDesc.append('%s is a ' % body.name + body.desc[0])
					try:
						newDesc.append(body.desc[1])
					except IndexError:
						pass
					
					for line in newDesc:
						text = font2.render(line,1,(0,0,0))
						screen.blit(text, (x,y))
						y += 22
						
					planetData = [
					("Atmo: "+str(body.atmosphere)),
					("Gravity: "+str(body.gravity)),
					("Year Length: "+str(body.yearLen))
					]
					
					for line in planetData:
						text = font2.render(line,1,(0,0,0))
						screen.blit(text, (x,y))
						y += 22
						
					
						
					
					
						
			
		
		self.backButton.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
		
		#self.buyOreButton.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
		#self.sellOreButton.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
			
		pygame.display.update()
	
		
	def event(self,e):
		if e.type == KEYDOWN:
			if e.key == K_ESCAPE:
				return game.NavUI(self.game)