
def buyItem(planet,itemClass,player):
	if(not player.canAddItem(itemClass)): raise NoSpace 
	cost = planet.items[itemClass][0].cost * planet.items[itemClass][1]
	if(player.cash < cost): raise NoCash
	player.addItem(itemClass)
	player.cash -= cost

def sellItem(planet,itemClass,player):
	if(not itemClass.sellable): raise NotSellable
	player.cash += planet.items[itemClass][0].cost / 1.5
	player.removeItem(itemClass)

def buyMineral(planet,amt,player):
	if(amt > planet.stock[0]): raise NoStock
	cost = planet.getMineralBuyPrice() * amt
	if(player.cash < cost): raise NoCash
	planet.stock[0] -= amt
	player.cash -= cost
	player.addMineral(amt)

def buyOre(planet,amt,player):
	if(amt > planet.stock[1]): raise NoStock
	cost = planet.getOreBuyPrice() * amt
	if(player.cash < cost): raise NoCash
	planet.stock[1] -= amt
	player.cash -= cost
	player.addOre(amt)

def buyWater(planet,amt,player):
	if(amt > planet.stock[2]): raise NoStock
	cost = planet.getWaterBuyPrice() * amt
	if(player.cash < cost): raise NoCash
	planet.stock[2] -= amt
	player.cash -= cost
	player.addWater(amt)

def buyFuel(planet,amt,player):
	if(amt > planet.stock[3]): raise NoStock
	cost = planet.getFuelBuyPrice() * amt
	if(player.cash < cost): raise NoCash
	planet.stock[3] -= amt
	player.cash -= cost
	player.addFuel(amt)
	
def sellMineral(planet,amt,player):
	if(amt + planet.stock[0] > planet.capacity): raise NoRoom
	cost = planet.getMineralSellPrice() * amt
	planet.stock[0] += amt
	player.cash += cost
	player.removeMineral(amt)

def sellOre(planet,amt,player):
	if(amt + planet.stock[1] > planet.capacity): raise NoRoom
	cost = planet.getOreSellPrice() * amt
	planet.stock[1] += amt
	player.cash += cost
	player.removeOre(amt)

def sellWater(planet,amt,player):
	if(amt + planet.stock[2] > planet.capacity): raise NoRoom
	cost = planet.getWaterSellPrice() * amt
	planet.stock[2] += amt
	player.cash += cost
	player.removeWater(amt)

def sellFuel(planet,amt,player):
	if(amt + planet.stock[3] > planet.capacity): raise NoRoom
	cost = planet.getFuelSellPrice() * amt
	planet.stock[3] += amt
	player.cash += cost
	player.removeFuel(amt)

def getMineralBuyPrice(planet):
	return planet.demand[0] * ( 1 - (planet.stock[0] / planet.capacity)) * 1000

def getOreBuyPrice(planet):
	return planet.demand[1] * ( 1 - (planet.stock[1] / planet.capacity)) * 1000

def getWaterBuyPrice(planet):
	return planet.demand[2] * ( 1 - (planet.stock[2] / planet.capacity)) * 1000

def getFuelBuyPrice(planet):
	return planet.demand[3] * ( 1 - (planet.stock[3] / planet.capacity)) * 1000
	
def getMineralSellPrice(planet):
	return planet.demand[0] * ( 1 - (planet.stock[0] / planet.capacity)) * 1500

def getOreSellPrice(planet):
	return planet.demand[1] * ( 1 - (planet.stock[1] / planet.capacity)) * 1500

def getWaterSellPrice(planet):
	return planet.demand[2] * ( 1 - (planet.stock[2] / planet.capacity)) * 1500

def getFuelSellPrice(planet):
	return planet.demand[3] * ( 1 - (planet.stock[3] / planet.capacity)) * 1500

