import math
import pygame
import ode

# Gets the top-down (z-axis) rotation from an ODE rotation matrix (ported from a post on the GameDev.net forums)
def getEuler(matrix):
	epsilon=0.0000001;
	if((matrix[2] < 1-epsilon) and (matrix[2] > -1+epsilon)):
		ky=-math.asin(matrix[2]);
		c=math.cos(ky);   
		return 270 - math.atan2(matrix[1]/c,matrix[0]/c) * 57.2958279088
	else:
		return 0
		
def gameTime():
	return pygame.time.get_ticks() / 1000.0
	
	
import types
def getParentClasses( c, seen=None ):
    """Python class base-finder"""
    if type( c ) == types.ClassType:
        if seen is None:
            seen = {}
        seen[c] = None
        items = [c]
        for base in c.__bases__:
            if not seen.has_key(base):
                items.extend( getParentClasses(base, seen))
        return items
    else:
        return list(c.__mro__)

class Callable:
    def __init__(self, anycallable):
        self.__call__ = anycallable